commit c9ac14ff9c26825295b77eadc08f58edc8c34999
Author: Eliška Mourycová <eliska.mourycova@seznam.cz>
Date:   Sat Jun 5 20:59:18 2021 +0200

    Re #9051. Prepared for testing.

diff --git a/Server/ServerApp/server_config b/Server/ServerApp/server_config
index 73e1807..440d9f5 100644
--- a/Server/ServerApp/server_config
+++ b/Server/ServerApp/server_config
@@ -1,7 +1,7 @@
 #
 # Tri Musketyri, ASWI 2021
 # This is the server configuration file. See the documentation for detailed information about its structure.
-# Pass this file as an argument to the server program when launching it.
+# Pass the path to this file as an argument to the server program when launching it.
 #
 
 # --- DATA FILES DOWNLOADING CONFIGURATION ---
diff --git a/Server/ServerAppFunctionalTests/DownloaderTests/DataDownloaderTesting.cs b/Server/ServerAppFunctionalTests/DownloaderTests/DataDownloaderTesting.cs
new file mode 100644
index 0000000..f548e86
--- /dev/null
+++ b/Server/ServerAppFunctionalTests/DownloaderTests/DataDownloaderTesting.cs
@@ -0,0 +1,54 @@
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+using ServerApp.DataDownload;
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace ServerAppFunctionalTests.DownloaderTests
+{
+	[TestClass]
+	public class DataDownloaderTesting
+	{
+		static DataDownloader dd;
+		[ClassInitialize]
+		public static void SetUpClass(TestContext context)
+		{
+			dd = new DataDownloader("./testDD", "http://openstore.zcu.cz/", "OD_ZCU_{type}_{month}_{year}_{format}.zip", "http://wttr.in/Plzen,czechia?format=j1"); ;
+		}
+
+		[TestMethod]
+		public void DirectoryCreated()
+		{
+			dd = new DataDownloader("./testDD", "http://openstore.zcu.cz/", "OD_ZCU_{type}_{month}_{year}_{format}.zip", "http://wttr.in/Plzen,czechia?format=j1");
+			bool rootDirExists = Directory.Exists(dd.RootDataDirectory);
+			Assert.IsTrue(rootDirExists);
+		}
+
+		[TestMethod]
+		public void DataSubdirectoriesCreated()
+		{
+
+		}
+
+		[TestMethod]
+		public void DataDownload()
+		{
+
+		}
+
+		[TestMethod]
+		public void DataRetrieve()
+		{
+
+		}
+
+		[TestMethod]
+		public void DateCompare()
+		{
+
+		}
+	}
+}
diff --git a/Server/ServerAppFunctionalTests/Predictor/PredictionControllerTests.cs b/Server/ServerAppFunctionalTests/Predictor/PredictionControllerTests.cs
index 3ba2167..f29c17e 100644
--- a/Server/ServerAppFunctionalTests/Predictor/PredictionControllerTests.cs
+++ b/Server/ServerAppFunctionalTests/Predictor/PredictionControllerTests.cs
@@ -24,7 +24,7 @@ namespace ServerApp.Predictor.Tests
         public void PredictSingleTimeWeatherTest()
         {
             System.IO.Directory.CreateDirectory(@".\data");
-            DataDownloader dd = new DataDownloader(@".\data\dd\", "http://openstore.zcu.cz/", "OD_ZCU_{type}_{month}_{year}_{format}.zip");
+            DataDownloader dd = new DataDownloader(@".\data\dd\", "http://openstore.zcu.cz/", "OD_ZCU_{type}_{month}_{year}_{format}.zip", "http://wttr.in/Plzen,czechia?format=j1");
             PredictionController instance = new PredictionController(new JsonParser(dd, new CsvDataLoader()), new DataParser(dd));
 
             dd.DownloadData(DataType.JIS, DataFormat.CSV, new DataDownload.Date(1, 2019), new DataDownload.Date(12, 2020));
diff --git a/Server/ServerAppFunctionalTests/TestingDataDownloader.cs b/Server/ServerAppFunctionalTests/TestingDataDownloader.cs
deleted file mode 100644
index 1850d5b..0000000
--- a/Server/ServerAppFunctionalTests/TestingDataDownloader.cs
+++ /dev/null
@@ -1,43 +0,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
-
-namespace ServerAppFunctionalTests
-{
-	[TestClass]
-	class TestingDataDownloader
-	{
-		[TestMethod]
-		public void DataDirectoryCreate()
-		{
-
-		}
-
-		[TestMethod]
-		public void DataSubdirectoriesCreate()
-		{
-
-		}
-
-		[TestMethod]
-		public void DataDownload()
-		{
-
-		}
-
-		[TestMethod]
-		public void DataRetrieve()
-		{
-
-		}
-
-		[TestMethod]
-		public void DateCompare()
-		{
-
-		}
-	}
-}