commit cb0b7cb903079345ac7080769055ecb7d174e738
Author: A-Konig <alex-nebulae@seznam.cz>
Date:   Wed Apr 21 19:59:46 2021 +0200

    re #8683 Fixing project dependencies problems

diff --git a/Server/ServerApp.sln b/Server/ServerApp.sln
index 0e1c084..40c86ce 100644
--- a/Server/ServerApp.sln
+++ b/Server/ServerApp.sln
@@ -3,7 +3,7 @@ Microsoft Visual Studio Solution File, Format Version 12.00
 # Visual Studio Version 16
 VisualStudioVersion = 16.0.31105.61
 MinimumVisualStudioVersion = 10.0.40219.1
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ServerApp", "ServerApp\ServerApp.csproj", "{B49B2821-751C-4032-8637-B4E9282DCF06}"
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ServerApp", "ServerApp\ServerApp.csproj", "{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}"
 EndProject
 Global
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
@@ -13,19 +13,19 @@ Global
 		Release|x64 = Release|x64
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Debug|x64.ActiveCfg = Debug|x64
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Debug|x64.Build.0 = Debug|x64
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Release|Any CPU.Build.0 = Release|Any CPU
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Release|x64.ActiveCfg = Release|x64
-		{B49B2821-751C-4032-8637-B4E9282DCF06}.Release|x64.Build.0 = Release|x64
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Debug|x64.ActiveCfg = Debug|x64
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Debug|x64.Build.0 = Debug|x64
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Release|Any CPU.Build.0 = Release|Any CPU
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Release|x64.ActiveCfg = Release|x64
+		{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}.Release|x64.Build.0 = Release|x64
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
 		HideSolutionNode = FALSE
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution
-		SolutionGuid = {CF3D6A57-E659-4E12-884C-6346F59A3735}
+		SolutionGuid = {93738D2E-8EB0-49A3-8335-3B0789068B98}
 	EndGlobalSection
 EndGlobal
diff --git a/Server/ServerApp/App.config b/Server/ServerApp/App.config
index 56efbc7..5cffe9b 100644
--- a/Server/ServerApp/App.config
+++ b/Server/ServerApp/App.config
@@ -1,6 +1,18 @@
-﻿<?xml version="1.0" encoding="utf-8" ?>
+﻿<?xml version="1.0" encoding="utf-8"?>
 <configuration>
     <startup> 
         <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.7.2" />
     </startup>
+  <runtime>
+    <assemblyBinding xmlns="urn:schemas-microsoft-com:asm.v1">
+      <dependentAssembly>
+        <assemblyIdentity name="System.Runtime.CompilerServices.Unsafe" publicKeyToken="b03f5f7f11d50a3a" culture="neutral" />
+        <bindingRedirect oldVersion="0.0.0.0-4.0.4.1" newVersion="4.0.4.1" />
+      </dependentAssembly>
+      <dependentAssembly>
+        <assemblyIdentity name="System.Threading.Tasks.Extensions" publicKeyToken="cc7b13ffcd2ddd51" culture="neutral" />
+        <bindingRedirect oldVersion="0.0.0.0-4.2.0.1" newVersion="4.2.0.1" />
+      </dependentAssembly>
+    </assemblyBinding>
+  </runtime>
 </configuration>
\ No newline at end of file
diff --git a/Server/ServerApp/Parser/Parsers/CsvParser.cs b/Server/ServerApp/Parser/Parsers/CsvParser.cs
index aac4145..e4672f9 100644
--- a/Server/ServerApp/Parser/Parsers/CsvParser.cs
+++ b/Server/ServerApp/Parser/Parsers/CsvParser.cs
@@ -1,4 +1,7 @@
 ﻿using Parser.OutputInfo;
+using ServerApp.Parser.InputData;
+using ServerApp.Parser.OutputInfo;
+using ServerApp.Parser.Parsers;
 using System;
 using System.Collections.Generic;
 using System.Globalization;
@@ -15,17 +18,19 @@ namespace Parser.Parsers
         LogInParser loginParser;
 
         public List<WeatherInfo> weatherList;
-        public List<JisInfo> jisList;
-        public List<LogInInfo> loginList;
+        public List<ActivityInfo> jisList;
+        public List<ActivityInfo> loginList;
 
         public CsvParser()
         {
             TagInfo.CreateDictionaries();
             path = "data/";
 
-            weatherParser = new WeatherParser();
-            jisParser = new JisParser();
-            loginParser = new LogInParser();
+            CsvDataLoader loader = new CsvDataLoader();
+
+            weatherParser = new WeatherParser(loader);
+            jisParser = new JisParser(loader);
+            loginParser = new LogInParser(loader);
         }
 
         public void Parse()
diff --git a/Server/ServerApp/Properties/AssemblyInfo.cs b/Server/ServerApp/Properties/AssemblyInfo.cs
index 76b7e53..db6444d 100644
--- a/Server/ServerApp/Properties/AssemblyInfo.cs
+++ b/Server/ServerApp/Properties/AssemblyInfo.cs
@@ -20,7 +20,7 @@ using System.Runtime.InteropServices;
 [assembly: ComVisible(false)]
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("b49b2821-751c-4032-8637-b4e9282dcf06")]
+[assembly: Guid("18fcfb20-b860-4147-8e7c-8a0dd84c55d4")]
 
 // Version information for an assembly consists of the following four values:
 //
diff --git a/Server/ServerApp/ServerApp.csproj b/Server/ServerApp/ServerApp.csproj
index 1d6c8ba..7b34622 100644
--- a/Server/ServerApp/ServerApp.csproj
+++ b/Server/ServerApp/ServerApp.csproj
@@ -1,4 +1,4 @@
-<?xml version="1.0" encoding="utf-8"?>
+﻿<?xml version="1.0" encoding="utf-8"?>
 <Project ToolsVersion="15.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <Import Project="..\packages\Microsoft.ML.1.5.5\build\netstandard2.0\Microsoft.ML.props" Condition="Exists('..\packages\Microsoft.ML.1.5.5\build\netstandard2.0\Microsoft.ML.props')" />
   <Import Project="..\packages\Microsoft.ML.CpuMath.1.5.5\build\netstandard2.0\Microsoft.ML.CpuMath.props" Condition="Exists('..\packages\Microsoft.ML.CpuMath.1.5.5\build\netstandard2.0\Microsoft.ML.CpuMath.props')" />
@@ -6,12 +6,11 @@
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProjectGuid>{B49B2821-751C-4032-8637-B4E9282DCF06}</ProjectGuid>
+    <ProjectGuid>{18FCFB20-B860-4147-8E7C-8A0DD84C55D4}</ProjectGuid>
     <OutputType>Exe</OutputType>
     <RootNamespace>ServerApp</RootNamespace>
     <AssemblyName>ServerApp</AssemblyName>
     <TargetFrameworkVersion>v4.7.2</TargetFrameworkVersion>
-	  <GenerateTargetFrameworkAttribute>false</GenerateTargetFrameworkAttribute>
     <FileAlignment>512</FileAlignment>
     <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
     <Deterministic>true</Deterministic>
@@ -46,7 +45,6 @@
     <LangVersion>7.3</LangVersion>
     <ErrorReport>prompt</ErrorReport>
     <Prefer32Bit>true</Prefer32Bit>
-    <RestoreProjectStyle>PackageReference</RestoreProjectStyle>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
     <OutputPath>bin\x64\Release\</OutputPath>
@@ -58,14 +56,71 @@
     <ErrorReport>prompt</ErrorReport>
     <Prefer32Bit>true</Prefer32Bit>
   </PropertyGroup>
-  <PropertyGroup>
-    <StartupObject>ServerApp.Program</StartupObject>
-  </PropertyGroup>
   <ItemGroup>
+    <Reference Include="Microsoft.ML, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.Core.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.CpuMath, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.CpuMath.1.5.5\lib\netstandard2.0\Microsoft.ML.CpuMath.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.Data, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.Data.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.DataView, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.DataView.1.5.5\lib\netstandard2.0\Microsoft.ML.DataView.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.KMeansClustering, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.KMeansClustering.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.PCA, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.PCA.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.StandardTrainers, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.StandardTrainers.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.ML.Transforms, Version=1.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.ML.1.5.5\lib\netstandard2.0\Microsoft.ML.Transforms.dll</HintPath>
+    </Reference>
+    <Reference Include="Newtonsoft.Json, Version=10.0.0.0, Culture=neutral, PublicKeyToken=30ad4fe6b2a6aeed, processorArchitecture=MSIL">
+      <HintPath>..\packages\Newtonsoft.Json.10.0.3\lib\net45\Newtonsoft.Json.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
+    <Reference Include="System.Buffers, Version=4.0.2.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Buffers.4.4.0\lib\netstandard2.0\System.Buffers.dll</HintPath>
+    </Reference>
+    <Reference Include="System.CodeDom, Version=4.0.0.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.CodeDom.4.4.0\lib\net461\System.CodeDom.dll</HintPath>
+    </Reference>
+    <Reference Include="System.Collections.Immutable, Version=1.2.3.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Collections.Immutable.1.5.0\lib\netstandard2.0\System.Collections.Immutable.dll</HintPath>
+    </Reference>
     <Reference Include="System.Core" />
     <Reference Include="System.IO.Compression" />
     <Reference Include="System.IO.Compression.FileSystem" />
+    <Reference Include="System.IO.Compression.ZipFile, Version=4.0.2.0, Culture=neutral, PublicKeyToken=b77a5c561934e089, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.IO.Compression.ZipFile.4.3.0\lib\net46\System.IO.Compression.ZipFile.dll</HintPath>
+      <Private>True</Private>
+      <Private>True</Private>
+    </Reference>
+    <Reference Include="System.Memory, Version=4.0.1.1, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Memory.4.5.3\lib\netstandard2.0\System.Memory.dll</HintPath>
+    </Reference>
+    <Reference Include="System.Numerics" />
+    <Reference Include="System.Numerics.Vectors, Version=4.1.3.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Numerics.Vectors.4.4.0\lib\net46\System.Numerics.Vectors.dll</HintPath>
+    </Reference>
+    <Reference Include="System.Runtime.CompilerServices.Unsafe, Version=4.0.4.1, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Runtime.CompilerServices.Unsafe.4.5.3\lib\net461\System.Runtime.CompilerServices.Unsafe.dll</HintPath>
+    </Reference>
+    <Reference Include="System.Threading.Channels, Version=4.0.2.0, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Threading.Channels.4.7.1\lib\net461\System.Threading.Channels.dll</HintPath>
+    </Reference>
+    <Reference Include="System.Threading.Tasks.Extensions, Version=4.2.0.1, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\packages\System.Threading.Tasks.Extensions.4.5.4\lib\net461\System.Threading.Tasks.Extensions.dll</HintPath>
+    </Reference>
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
     <Reference Include="Microsoft.CSharp" />
@@ -74,101 +129,117 @@
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
-
     <Compile Include="Connection\SocketListener.cs" />
     <Compile Include="DataDownload\DataDownloader.cs" />
-    <Compile Include="obj\Debug\.NETFramework,Version=v4.7.2.AssemblyAttributes.cs" />
-
-    <Compile Include="Predictor\IPredictor.cs" />
-    <Compile Include="Predictor\ModelInput.cs" />
-    <Compile Include="Predictor\ModelOutput.cs" />
-    <Compile Include="Predictor\NaiveBayesClassifier.cs" />
-
     <Compile Include="Parser\InputData\CsvDataLoader.cs" />
     <Compile Include="Parser\InputData\DataLoader.cs" />
     <Compile Include="Parser\InputData\JisInstance.cs" />
     <Compile Include="Parser\InputData\LogInInstance.cs" />
     <Compile Include="Parser\InputData\WeatherInstance.cs" />
     <Compile Include="Parser\OutputInfo\ActivityInfo.cs" />
+    <Compile Include="Parser\OutputInfo\JisInfo.cs" />
+    <Compile Include="Parser\OutputInfo\LogInInfo.cs" />
+    <Compile Include="Parser\OutputInfo\LumInfo.cs" />
+    <Compile Include="Parser\OutputInfo\RainInfo.cs" />
+    <Compile Include="Parser\OutputInfo\TempInfo.cs" />
     <Compile Include="Parser\OutputInfo\WeatherConditions.cs" />
     <Compile Include="Parser\OutputInfo\WeatherInfo.cs" />
+    <Compile Include="Parser\OutputInfo\WindInfo.cs" />
+    <Compile Include="Parser\Parsers\CsvParser.cs" />
     <Compile Include="Parser\Parsers\DataParser.cs" />
     <Compile Include="Parser\Parsers\JisParser.cs" />
     <Compile Include="Parser\Parsers\LogInParser.cs" />
     <Compile Include="Parser\Parsers\TagInfo.cs" />
     <Compile Include="Parser\Parsers\WeatherParser.cs" />
+    <Compile Include="Predictor\IPredictor.cs" />
+    <Compile Include="Predictor\ModelInput.cs" />
+    <Compile Include="Predictor\ModelOutput.cs" />
+    <Compile Include="Predictor\NaiveBayesClassifier.cs" />
     <Compile Include="Program.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
   <ItemGroup>
     <None Include="App.config" />
-    <None Include="data\jis\OD_ZCU_JIS_06_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\jis\OD_ZCU_JIS_09_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\jis\OD_ZCU_JIS_10_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\jis\OD_ZCU_JIS_11_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\jis\OD_ZCU_JIS_13_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\jis\OD_ZCU_JIS_12_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\login\OD_ZCU_STROJE_06_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\login\OD_ZCU_STROJE_09_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\login\OD_ZCU_STROJE_10_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\login\OD_ZCU_STROJE_11_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\login\OD_ZCU_STROJE_12_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\login\OD_ZCU_STROJE_13_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\weather\OD_ZCU_POCASI_13_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\weather\OD_ZCU_POCASI_06_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\weather\OD_ZCU_POCASI_09_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\weather\OD_ZCU_POCASI_10_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\weather\OD_ZCU_POCASI_11_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="data\weather\OD_ZCU_POCASI_12_2019.CSV">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
+    <None Include="data\auto\JIS\OD_ZCU_JIS_00_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_01_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_02_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_03_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_04_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_05_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_06_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_06_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_07_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_07_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_08_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_08_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_09_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_09_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_10_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_10_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_11_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_11_2020.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_12_2019.CSV" />
+    <None Include="data\auto\JIS\OD_ZCU_JIS_12_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_00_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_01_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_02_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_03_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_04_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_05_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_06_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_06_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_07_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_07_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_08_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_08_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_09_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_09_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_10_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_10_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_11_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_11_2020.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_12_2019.CSV" />
+    <None Include="data\auto\POCASI\OD_ZCU_POCASI_12_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_00_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_01_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_02_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_03_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_04_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_05_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_06_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_06_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_07_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_07_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_08_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_08_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_09_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_09_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_10_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_10_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_11_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_11_2020.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_12_2019.CSV" />
+    <None Include="data\auto\STROJE\OD_ZCU_STROJE_12_2020.CSV" />
+    <None Include="data\jis\OD_ZCU_JIS_06_2019.CSV" />
+    <None Include="data\jis\OD_ZCU_JIS_09_2019.CSV" />
+    <None Include="data\jis\OD_ZCU_JIS_10_2019.CSV" />
+    <None Include="data\jis\OD_ZCU_JIS_11_2019.CSV" />
+    <None Include="data\jis\OD_ZCU_JIS_12_2019.CSV" />
+    <None Include="data\jis\OD_ZCU_JIS_13_2019.CSV" />
+    <None Include="data\login\OD_ZCU_STROJE_06_2019.CSV" />
+    <None Include="data\login\OD_ZCU_STROJE_09_2019.CSV" />
+    <None Include="data\login\OD_ZCU_STROJE_10_2019.CSV" />
+    <None Include="data\login\OD_ZCU_STROJE_11_2019.CSV" />
+    <None Include="data\login\OD_ZCU_STROJE_12_2019.CSV" />
+    <None Include="data\login\OD_ZCU_STROJE_13_2019.CSV" />
+    <None Include="data\weather\OD_ZCU_POCASI_06_2019.CSV" />
+    <None Include="data\weather\OD_ZCU_POCASI_09_2019.CSV" />
+    <None Include="data\weather\OD_ZCU_POCASI_10_2019.CSV" />
+    <None Include="data\weather\OD_ZCU_POCASI_11_2019.CSV" />
+    <None Include="data\weather\OD_ZCU_POCASI_12_2019.CSV" />
+    <None Include="data\weather\OD_ZCU_POCASI_13_2019.CSV" />
     <None Include="packages.config" />
   </ItemGroup>
-  <ItemGroup>
-    <PackageReference Include="Microsoft.ML">
-      <Version>1.5.2</Version>
-    </PackageReference>
-    <PackageReference Include="System.Runtime.CompilerServices.Unsafe">
-      <Version>5.0.0</Version>
-    </PackageReference>
-  </ItemGroup>
-  <ItemGroup>
-    <WCFMetadata Include="Connected Services\" />
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <Target Name="EnsureNuGetPackageBuildImports" BeforeTargets="PrepareForBuild">
     <PropertyGroup>
diff --git a/Server/ServerApp/ServerApp.csproj.user b/Server/ServerApp/ServerApp.csproj.user
deleted file mode 100644
index 9b86104..0000000
--- a/Server/ServerApp/ServerApp.csproj.user
+++ /dev/null
@@ -1,6 +0,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<Project ToolsVersion="Current" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-  <PropertyGroup>
-    <ProjectView>ShowAllFiles</ProjectView>
-  </PropertyGroup>
-</Project>
\ No newline at end of file
diff --git a/Server/ServerApp/packages.config b/Server/ServerApp/packages.config
index dc4d10d..de47ae5 100644
--- a/Server/ServerApp/packages.config
+++ b/Server/ServerApp/packages.config
@@ -7,6 +7,7 @@
   <package id="System.Buffers" version="4.4.0" targetFramework="net472" />
   <package id="System.CodeDom" version="4.4.0" targetFramework="net472" />
   <package id="System.Collections.Immutable" version="1.5.0" targetFramework="net472" />
+  <package id="System.IO.Compression.ZipFile" version="4.3.0" targetFramework="net472" />
   <package id="System.Memory" version="4.5.3" targetFramework="net472" />
   <package id="System.Numerics.Vectors" version="4.4.0" targetFramework="net472" />
   <package id="System.Reflection.Emit.Lightweight" version="4.3.0" targetFramework="net472" />